"""
version : RenderOctaneSequence_0.2
This script render to disk the sequence from render setting start frame to end frames, but without using batch render.
This is handy when for some reson Octane works in IPR, but not at batch rendering.
Usage : Just drop the code in a shelf and make it a "python" button.
"""

from maya.api.OpenMaya import *
import maya.mel as mel
import maya.cmds as mc

CALLBACK_ID = None

def renderFrame():
    mel.eval("evalDeferred \"RenderIntoNewWindow\";")

def rStart():
    global CALLBACK_ID
    if CALLBACK_ID is None:
        print ("start")
        CALLBACK_ID = MCommandMessage.addCommandOutputCallback(getMsg)

def rEnd():
    global CALLBACK_ID
    if not CALLBACK_ID is None:
        MMessage.removeCallback(CALLBACK_ID)
        CALLBACK_ID = None
        print ("end")

def getMsg(msg, msgType, clientData):
    if mc.currentTime( q=True ) < mc.getAttr("defaultRenderGlobals.endFrame"):
        line = str(msg)
        octmsg = "render is finished"
        if octmsg in line:
            mc.currentTime(mc.currentTime( q=True )+1)
            renderFrame()
    else :
        rEnd()


mc.setAttr("defaultRenderGlobals.animation", 1);
mc.currentTime(mc.getAttr("defaultRenderGlobals.startFrame"))
rStart()
renderFrame()
